## Script (Python) "portlets_ColorSelector"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=color,divid,id
##title=
##
#    CMFPortlets 0.5.2  
#    Portlets for the CMF. February 5th, 2003. 
#    Copyright (c) Augusto Cabrera. All rights reserved. GPL licensed with exceptions. Read LICENSE.txt
#
#    The javascript used here is a modified version of "Color Slider", code found at the japanese page:
#    http://report.s22.xrea.com/
#    Author's email: report@s22.xrea.com

REQUEST = context.REQUEST
out = """

<html>
<head><title>CMFPortlets 0.5.2 Interactive RGB Color Selector</title>
<style type=text/css rel=stylesheet>
BODY {MARGIN: 0px}
FORM {MARGIN: 0px}
.top TD {FONT-SIZE: x-small}
.i {WIDTH: 505px; HEIGHT: 1px}
#s1 {OVERFLOW-X: scroll; WIDTH: 250px; SCROLLBAR-BASE-COLOR: #FF3232; HEIGHT: 0px}
#s2 {OVERFLOW-X: scroll; WIDTH: 250px; SCROLLBAR-BASE-COLOR: #32FF32; HEIGHT: 0px}
#s3 {OVERFLOW-X: scroll; WIDTH: 250px; SCROLLBAR-BASE-COLOR: #3232FF; HEIGHT: 0px}
input {FONT-SIZE: 7pt;}
</style>

<SCRIPT language="JavaScript">

var r1 = 0;
var f1 = 0;

function hextodec(n){
        var decn = n.toString(16);
	if(decn.length == 1){ decn = "0" + decn; }
        return decn;}

function color(t,n){
        var num10 = t.scrollLeft;
	document.forms["f" + n].elements[0].value = hextodec(num10);
	color_change();}


function color2(t,n){
	var num16 = "0x" + t.elements[0].value;
	num16 = parseInt(num16);
	var num10 = num16.toString(10);
	document.all.item("s" + n).scrollLeft = num16;
	color_change();
}

function color_change(){
                   esto = document.forms["f1"].elements[0].value;
                   eso = document.forms["f2"].elements[0].value;
                   aquello =  document.forms["f3"].elements[0].value;
	var rgb = "#" + esto  + eso + aquello;
	if (r1 == 0) { document.all.bg.style.backgroundColor = rgb; }
	document.forms["rgb"].elements[0].value = rgb;
        opener.document.propsform.%s.value = rgb; 
        opener.document.all.%s.style.backgroundColor = rgb;  
}

function rc(r){
	r1 = r;
	var rgb;
	if(r == 0){ rgb = document.all.bg.style.backgroundColor; }
	var red = "0x" + rgb.substr(1,2);
	var green = "0x" + rgb.substr(3,2);
	var blue = "0x" + rgb.substr(5,2);
	document.all.s1.scrollLeft = red.toString(10);
	document.all.s2.scrollLeft = green.toString(10);
	document.all.s3.scrollLeft = blue.toString(10);
}

function ol(){ document.forms["selta"].elements[0].click(); }

function rgb_change(t){
	var rgb = t.elements[0].value.replace("#","");;
	var red = "0x" + rgb.substr(0,2);
	var green = "0x" + rgb.substr(2,2);
	var blue = "0x" + rgb.substr(4,2);
	red.toString(10);
	document.all.s1.scrollLeft = red.toString(10);
	document.all.s2.scrollLeft = green.toString(10);
	document.all.s3.scrollLeft = blue.toString(10);
}
</SCRIPT>


</head>
<BODY onload=ol();>

<DIV id=bg style="HEIGHT: 120%%; BACKGROUND-COLOR: #%s" align=center>

  <TABLE cellSpacing=0 cellPadding=0 border=0>
    <TR> 
      <TD> 
        <DIV id=s1 onscroll=color(this,1)><IMG class=i 
      src="s.gif"></DIV>
      </TD>
      <TD> 
        <FORM name=f1 onsubmit="color2(this,1);return false;"  action=http://>
          <INPUT id=ts1 size=4 value=00>
          <INPUT type="submit" value="set">
        </FORM>
      </TD>
    </TR>
    <TR> 
      <TD> 
        <DIV id=s2 onscroll=color(this,2);><img class=i  src="s.gif"></DIV>
      </TD>
      <TD> 
        <FORM name=f2 onsubmit="color2(this,2);return false;" action=http://>
          <INPUT id=ts2 size=4 value=00>
          <INPUT type="submit" value="set">
        </FORM>
      </TD>
    </TR>
    <TR> 
      <TD> 
        <DIV id=s3 onscroll=color(this,3);><IMG class=i  src="s.gif"></DIV>
      </TD>
      <TD> 
        <FORM name=f3 onsubmit="color2(this,3);return false;"  action=http://>
          <INPUT id=ts3 size=4 value=00>
          <INPUT type="submit" value="set">
        </FORM>
      </TD>
    </TR>
    <TR> 
      <TD colspan="2" align="center"> 
        <FORM name=selta> <INPUT onclick=rc(0) type=hidden CHECKED name=c>  </FORM>
      

		<FORM name=rgb onsubmit="rgb_change(this);return false;"  action=http://>
          <INPUT id=ts3 size=10 value=#000000>
          <INPUT type=submit value=go>
        </FORM>
	  
	  </TD>
    </TR>
  </TABLE>
 </DIV>

</body>

</html>


""" % (id, divid, color)



return out
