## Script (Python) "portlets_manageUserSettings"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=mode=None
##title=
##
#    CMFPortlets 0.5.2  
#    Portlets for the CMF. February 5th, 2003. 
#    Copyright (c) Augusto Cabrera. All rights reserved. GPL licensed with exceptions. Read LICENSE.txt

ps = context.portal_membership.getAuthenticatedMember().getProperty('personal_selections')
REQUEST = context.REQUEST
psh = context.propertysheets.get('portlets_user_properties')
form = context.REQUEST.form
ids = form.get('ids', None)


if REQUEST.has_key('p') and REQUEST.has_key('col') and REQUEST.has_key('box'):
    p = REQUEST.p
    col = int(REQUEST.col)- 1
    temp = ps
    box = REQUEST.box
    for x in range(len(ps)):
        if ps[x][0] == p:
            column_content = temp[x][1]['pcolums'][col][1]
            for item in column_content:     #new starting here
                if item[0]== box:
                    # item[2] is the dictionary of portlet properties as selected by user                   
                    for it in ids:
                        if it not in item[2].keys():  # if the ids properties are not in the user stored ones.
                            # We need to perform a check in here, so that we add the properties that are really from the object
                            psh = context.propertysheets.get('portlets_user_properties')                            
                            if it in psh.propertyIds():
                                typ = [z['type'] for z in psh.propertyMap() if z['id'] == it ] or [0]
                                item[2][it] = [form[it], typ[0]]  # where form[it] is the user proportioned value
                        else:
                            tp = item[2][it][1]
                            if tp == 'boolean':
                                try: v = form[it]
                                except: v = 0
                            else:
                                v = form[it]          # this is potentially problematic, as it is where both set of properties 
                                                      # collide. Needs to write a proper error handling.
                            item[2][it][0] = v                            
                        
                    context.portal_membership.getAuthenticatedMember().setProperties(personal_selections=temp)
                    urlstring = "/portlet_settings?p=%s&col=%s&box=%s" % (p, REQUEST.col, box)
                    return REQUEST.RESPONSE.redirect(context.absolute_url()+ urlstring )
    return None
