## Script (Python) "portlets_user_input"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=height, content_boxes, item_height=None
##title=FROM TESTDYN
##
#    CMFPortlets 0.5.2  
#    Portlets for the CMF. February 5th, 2003. 
#    Copyright (c) Augusto Cabrera. All rights reserved. GPL licensed with exceptions. Read LICENSE.txt

scripts_url = context.portlets_option_chooser_url() 

def create_item(current_id, current_title=None):
    
    if current_title is not None:
        current_title_trunc = simple_filter(context.truncID(current_title, 13))
        current_title_line = simple_filter(current_title) + '&nbsp;(id:' + current_id + ')'
    item = """
		"'%s'"
			+"|'<a title=%s ><font face=Verdana,Arial,Helvetica,sans-serif size=1 STYLE=cursor:hand; >%s</font></a>'"
			+"|'<font face=Verdana,Arial,Helvetica,sans-serif size=1 STYLE=cursor:hand; >%s</font>'"
			+"|'%s'"
			+"|''|'#ADC1CF'",
""" % (current_id, current_title_line, current_title_trunc, current_title_trunc, current_title_line )
    return item


# CALLING THE MEMBER PORTLETS RECORD.
REQUEST = context.REQUEST
p = REQUEST.p   # we get the page number from the request. 
ps = context.portal_membership.getAuthenticatedMember().getProperty('personal_selections')  # the record
numpags = len(ps)  # the number of pages stored in the record.

for x in range(numpags):
    if ps[x][0] == p:
        arrange = ps[x][1]['pcolums'] 
        break
var = [x[1] for x in arrange] # the content of pcolumns, that is, the inner content of each page, grouped in lists. Doesn't
                              # contain titles.


# FINDING AVAILABLE ITEMS

items_used = []   # provided by the user's stored data, items_used is a plain list of all portlets no matter what columns they belong to.
for x in range(len(var)):
    col = var[x]
    for y in col:
        items_used.append((y[0],y[1]))

def format_title(title):
    if title == '': return "Untitled portlet"
    else: return title
        
items_available = [(idx,path,title) for (idx,path,title,state) in content_boxes if (idx,path) not in items_used] 
#return items_available

def getTitle(id,path):                # Need to get titles this way, as titles aren't stored when users selects portlets. Should be less
    for i,p,t,s in content_boxes:     # resource-consuming than to perform a restricted traverse, anyway. 
        if (id,path) == (i,p):
            if t == '':
                return "Untitled qortlet"
            else:
                return t
    return "Untitled xorlet"


def simple_filter(ob):
    a = ob.replace("'","&#39;")
    return a.replace(" ",'&nbsp;')

#--------------------------------------------------------------------------------------------------------------------------
choices_items = ''
for id,path,title in items_available:
    if title == '':
        title = 'Untitled zortlet'
    choices_items = choices_items + create_item(id,title)
choices_items = choices_items[:-2] + '\n' #	)\n'  


#right columns:  
numero_columnas = len(var)
firstCol = """
		"", """
single_col = """"", """
remaining_columnas =  numero_columnas - 1
right_columns = "%s%s" % (firstCol, single_col*remaining_columnas)
right_columns = right_columns[:-2]

#control = "//hola:" + str(var) + '\n'

#--------------------------------------------------------------------------------------------------------------------------
right_columns_array = ''
for x in range(len(var)):
    temp_right_columns_array = ''
    current_column = str(x)
    row = var[x]
    init = """
	stRightChoices%s=new Array(
""" % (x)
    for y in row:
    	item_id = y[0]  # id of each column, in the right order
    	item_path = y[1]
    	item_title = getTitle(item_id,item_path)
    	#item_title = simple_filter(item_title)
    	temp_right_columns_array = temp_right_columns_array + create_item(item_id, item_title)    	
    right_columns_array = right_columns_array + init + temp_right_columns_array[:-2] + '\n	)\n'
     	


ui = """
	//preloadImages('images/cow2.gif','images/vt2.gif','images/cal2.gif')

	startLeftChoices=new Array(
%s			
	)

	allRightChoices=new Array(
%s
	)

%s      	

	//User-provided constantsjj
	bigLHeight= %s;
	//bigLWidth= 800;
	bigLWidth= DynAPI.document.getWidth();
	listsTopOMargin= 30;
	listsLeftOMargin= 6;
	listsLeftMargin= 1;
	optionsTopMargin= 2;
	selTopMargin= 2;
	selTitleMargin= 3;
	listItemHeight= 20;
	listItemSep= 1;
	descHeight= 20;

 """ % (choices_items, right_columns, right_columns_array, height)

print ui #control2 + ui
return printed
