def portlets_afteradd(self):
    import OFS.Folder
    from Products.CMFCore.utils import _getAuthenticatedUser
    if _getAuthenticatedUser( self ).allowed( self, ('Owner', 'Manager') ):        

        if self.Type()=='Portlet' and self.meta_type=='Skinned Folder':
            self.manage_addProperty('box_padding', 4,'int')
            self.manage_addProperty('iframe_height', 0,'int')
            self.manage_addProperty('path', '','string')
            self.manage_addProperty('render_path', 0,'boolean')
            self.manage_addProperty('portlet_scripts', '','text')
            self.manage_addProperty('portlet_styles', '','text')

            self.manage_options = (	{'label':'Public', 'action':'portlets_provideUserProperties'}, ) \
                                         + OFS.Folder.Folder.manage_options \
                                         + ({'label':'ESI', 'action':'portlets_manageESIcacheProperties'}, ) 

            self.propertysheets.manage_addPropertySheet('portlets_user_properties', 'user_properties')
            self.propertysheets.manage_addPropertySheet('portlets_ESI_cacheproperties', 'ESI_properties')
            
            r = self.propertysheets.get('portlets_user_properties')
            #r.manage_addProperty('enable_public_properties', 0,'boolean')
            self.REQUEST.response.redirect( self.absolute_url() + '/portlet_edit_form')

        else:
            return "No way"
    else:
        raise 'Authorization Error', ("You're not allowed")

