## Script (Python) "portlets_BoxBuilder"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=box_title, box_content, p, col, box, use_table=None, box_skin=None, edit_url=None, vmo=None
##title=The boxes' skins repository (at code level)
##
#    CMFPortlets 0.5.2  
#    Portlets for the CMF. February 5th, 2003. 
#    Copyright (c) Augusto Cabrera. All rights reserved. GPL licensed with exceptions. Read LICENSE.txt


def cooked_content(bcontent, utable=None):
    if utable:  #we use a table surrounding the contentto provide the box padding.
        content = "<table cellpadding=%s width=100%%><tr><td>%s</td></tr></table>" % (utable, bcontent)
        return content
    else:
        return bcontent


if edit_url != 0:
    edit_url = "%s?p=%s&col=%s&box=%s" % (edit_url,p,col,box)
    edit_icon = """<TD height="16" valign="middle"><A href="%s" target="_blank"><IMG
                    src="icon_edit.gif" border=0 align="middle"></A></TD>""" % (edit_url)
else:
    edit_icon = ''
delete_url = "portlets_garage?delete=content&p=%s&col=%s&box=%s" % (p,col,box)
remove_icon="<a href=portlets_garage?delete=content&p=%s&col=%s&box=%s  ><img src='icon_remove.gif' border='0' ></a>" % (p,col,box)

if box_skin in ['default','type1','type2']:
    color_table = {'default':'#336699', 'type1':'#E4072E', 'type2':'#959500'}
    bgcolor = color_table[box_skin]
    thebox = """<TABLE cellSpacing=0 cellPadding=1 width="100%%" bgColor=#cccccc border=0><TR><TD><TABLE cellSpacing=0 cellPadding=0 
width="100%%" border=0><TR><TD><TABLE cellSpacing=0 cellPadding=0 width="100%%" border=0><TR valign="middle" bgColor=%s><TD width=10 
height="16"><IMG height=16 src="spacer.gif" width=10></TD><TD width="100%%" height="16"><font face="Verdana,Arial,Helvetica,sans-serif"
size="2" color="#ffffff"><B>%s</B></font></TD>%s<TD width=10 height="16">%s</TD></TR></TABLE></TD></TR><TR vAlign=top
bgColor=#ffffff nowrap><TD align=top>%s</TD></TR></TABLE></TD></TR></TABLE>
""" % (bgcolor, box_title, edit_icon, remove_icon, cooked_content(box_content, use_table) )
    return thebox


if box_skin == 'type3':
    bgcolor = '#FFFFFF'
    thebox = """<TABLE cellSpacing=0 cellPadding=1 width="100%%" bgColor=#cccccc border=0><TR><TD><TABLE cellSpacing=0 cellPadding=0 
width="100%%" border=0><TR><TD><TABLE cellSpacing=0 cellPadding=0 width="100%%" border=0><TR valign="middle" bgColor=%s><TD width=10 
height="16"><IMG height=16 src="spacer.gif" width=10></TD><TD width="100%%" height="16"><font face="Verdana,Arial,Helvetica,sans-serif"
size="2" color="#666666"><B>%s</B></font></TD>%s<TD width=10 height="16">%s</TD></TR><tr bgColor=#cccccc><td colspan="4"><IMG height=1 
src="spacer.gif" width=10></td></tr></TABLE></TD></TR><TR vAlign=top bgColor="#ffffff" nowrap><TD
align=top>%s</TD></TR></TABLE></TD></TR></TABLE>
""" % (bgcolor, box_title, edit_icon, remove_icon, cooked_content(box_content, use_table) )
    return thebox



elif box_skin == 'noskin':
    if vmo == '1':
        thebox = """<table width=100%%><tr><td><a href="%s" target="_blank">edit</a> |  <a href="%s" target="_blank">delete</a>
        </td></tr><tr><td>%s</td></tr></table>""" % (edit_url, delete_url, box_content)
        return thebox
    else:
        return box_content
    
else:
    bgcolor = '#336699'
    thebox = """<TABLE cellSpacing=0 cellPadding=1 width="100%%" bgColor=#cccccc border=0><TR><TD><TABLE cellSpacing=0 cellPadding=0
width="100%%" border=0><TR><TD><TABLE cellSpacing=0 cellPadding=0 width="100%%" border=0><TR valign="middle" bgColor=%s ><TD width=10
height="16"><IMG height=16 src="spacer.gif" width=10></TD><TD width="100%%" height="16"><font face="Verdana, Arial, Helvetica,
sans-serif" size="2" color="#ffffff"><B>%s</B></font></TD>%s<TD width=10 height="16">%s</TD></TR></TABLE></TD></TR><TR vAlign=top
bgColor=#ffffff nowrap><TD align=top>%s</TD></TR></TABLE></TD></TR></TABLE>
""" % (bgcolor, box_title, edit_icon, remove_icon, cooked_content(box_content, use_table) )
    return thebox
