## Script (Python) "portlets_PageScriptsCustomsBureau"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=scripts_string
##title=Customs office for scripts of portlets-in-page
##
# Not implemented.
#
# Developers guidelines:
# =====================
# Workspaces are prepared to store two types of strings lists: Fixed and dynamic javascripts
# elements. Fixed are those that are tied to the workspace independently of the existence of a 
# portlet, so that they rule the behaviour of the whole workspace, and portlets that just uses them.
# Different fixed javascripts sets can be assigned to each workspace, but it's probable that the 
# latter are likely to store just the same one general, site-wide set.
#
# On the other hand, the dynamic set of javascripts elements are provided by portlets, once they are
# added to the workspace. Although many functions will work just in place (embedded in the rendered
# box), there are others that need to be imported or placed in the page head tag. For both cases, 
# this customs bureau performs the checks, finds if the function already exists in its registry, and 
# if not, registers it and place the functions, variables and calls where they make sense, according
# to the portlet requirements. If there are elements that need to be at the page head tag, it will
# add them to the dynamic set, and will stay there until the portlet is removed from the workspace.
# Javascript elements that don't need to be at the head, can stay within the portlet, as long as 
# they aren't repeated at any other part of the workspace. (Example: When you ensamble a workspace 
# out of the same portlet object, but differently customized, only one of them could register and
# deliver its javascripts elements.)
#
#    CMFPortlets 0.5.2  
#    Portlets for the CMF. February 5th, 2003. 
#    Copyright (c) Augusto Cabrera. All rights reserved. GPL licensed with exceptions. Read LICENSE.txt


return scripts_string
