## Script (Python) "portlets_StylesheetsCustomsBureau"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=styles_string
##title=Customs office for styles of portlets-in-page
##
# Not implemented.
#
# Developers guidelines:
# =====================
# Workspaces are prepared to store two types of styles lists: Fixed and dynamic stylesheets.
# Fixed are those that are tied to the workspace independently of the existence of a portlet, so that
# they rule the look and feel of the empty workspace, and portlets that just uses them. Different 
# fixed stylesheets can be assigned to each workspace, but it's probable that the latter are likely
# to store just the same general, site-wide one.
#
# On the other hand, the dynamic set of stylesheets are provided by portlets, once they are
# added to the workspace. Although many functions will work just in place (embedded in the rendered
# box), there are others that need to be imported or placed in the page head tag, as when they 
# contain styles for the whole page elements. For both cases, this customs bureau performs the checks,
# finds if the style already exists in its registry, and if not, registers it and place the 
# styles tag strings where they make sense, according to the portlet requirements. If there are 
# elements that need to be at the page head tag, it will add them to the dynamic set, and will stay 
# there until the portlet is removed from the workspace.
# Stylesheets that don't need to be at the head, can stay within the portlet, as long as 
# they aren't repeated at any other part of the workspace. (Example: When you ensamble a workspace 
# out of the same portlet object, but differently customized, only one of them could register and
# deliver its styles.)
#
#    CMFPortlets 0.5.2  
#    Portlets for the CMF. February 5th, 2003. 
#    Copyright (c) Augusto Cabrera. All rights reserved. GPL licensed with exceptions. Read LICENSE.txt


return styles_string
